//----------------------------------------------------------------------------
//  Body: CDataStructure.cpp, v 1.0                           2007/04/16    //
//                                                                          //
//  Goofie TPC ALICE Program Library                                        //
//  Copyright (C) ALICE collaboration, 2007                                 //
//                                                                          //
//  Last modified in CVS                                                    //
//  Author: D. Antonczyk                                                    //
//----------------------------------------------------------------------------

#include <iostream>

#include "CMacroDef.h"
#include "SConfigData.h"

#include "CDataStructure.h"

using namespace std;


CDataStructure::CDataStructure() : AliGoofieRawEvent(SConfigData::fNumberOfADCSampels)
{
   DEBUGINFO("Debuge Info => CDataStructure object created",0)
}


CDataStructure::CDataStructure(const CDataStructure &_data) : AliGoofieRawEvent(_data)
{
   DEBUGINFO("Debuge Info => copy constructor of CDataStructure used",0)
}

CDataStructure::CDataStructure(const AliGoofieRawEvent &_data) : AliGoofieRawEvent(_data)
{
   DEBUGINFO("Debuge Info => constructor CRawEvent to CDataStructure used",0)
}


CDataStructure & CDataStructure::operator=(const CDataStructure &_data)
{
  if(this!=&_data) {

     AliGoofieRawEvent &refData = *this;
     refData = _data;
    
     DEBUGINFO("Debuge Info => overloaded = operator of CDataStructure used",0)
  }
  return *this;
}

CDataStructure::operator AliGoofieRawEvent()
{
   return *this;
}

CDataStructure::~CDataStructure()
{ 
   DEBUGINFO("Debuge Info => CDataStructure object destroyed",0)
}
