//----------------------------------------------------------------------------
//  Body: CEventGenerator.cpp, v 1.0                           2007/11/14   //
//                                                                          //
//  Goofie TPC ALICE Program Library                                        //
//  Copyright (C) ALICE collaboration, 2007                                 //
//                                                                          //
//  Last modified in CVS                                                    //
//  Author: D. Antonczyk                                                    //
//----------------------------------------------------------------------------

#include <iostream>

#include "TFile.h"

#include "SConfigData.h"
#include "CEventGenerator.h"

using namespace std;


CEventGenerator::CEventGenerator()
{
   fSlowControlValue = 0;                    // counter
   
   fMode = SConfigData::fGenerationMode;     // 1=True Event, 2=True event Smeared, 3=intiger runbers, worko only with compilation option "NO_HARDWARE_REQUIRED"
}

CEventGenerator::~CEventGenerator()
{
   
}


unsigned int Initialize()
{
   unsigned int err = 0;
 //   TFile    *lGenFile  = NULL;
//    TTree    *lGenTree  = NULL;
//    CPack    *lGenPack  = NULL; 
   
//    // Get events from tree, "ev-1 Near, ev-2 Far"
//    // Open file with events
//    try {
//       lGenFile = new TFile(SConfigData::fTrueEventDataFileLocation.c_str());
//       lGenTree = (TTree*)lGenFile->Get("Tree");

//       //Set address of CRawData
//       lGenPack = new CRawData();
//       lGenTree->SetBranchAddress("CPack", &lGenPack);
//       lGenTree->SetBranchStatus("*", 1);
//       // get number of event
//       int lNPack = (Int_t) lGenTree->GetEntries();
//       // read pack/events
//       if(lNPack<0) throw err = 100;
//       // clear pack
//       lGenPack->Clear();
//       // get first pack
//       int packOK = lGenEvent->GetEvent(0);
//       if(packOK < 0) {
// 	 cout << "Error event number = " <<  ev << endl;
// 	 throw err = 100;
//       }
//       // fill CDataStructures
//       for(int rawEvent=0; rawEvent<2; ++rawEvent) {
// 	 CRawData *lRAWEvent = lGenPack->getRawData(0); // near


//       }
      
//       //CDataStructure  fEventBufferNear;
//       //CDataStructure  fEventBufferFar;
      
//    } catch (...) {
//       err = 1;
//    }
//    // delete 
//    if(lGenTree) {
//       delete lGenTree;
//       lGenTree = NULL;
//    }
//    if(lGenPack) {
//       delete lGenPack;
//       lGenPack = NULL;
//    }
//    if(lGenFile) {
//       lGenFile->Close();
//       delete lGenFile;
//       lGenFile = NULL;
//    }
   return err;
}

void CEventGenerator::FillWithRealEvent(CDataStructure *_eventStr)
{
   // set event
   if(fRandomNumber.Rndm() >= 0.5) {
      _eventStr->operator=(fEventBufferNear);
   } else {
      _eventStr->operator=(fEventBufferFar);
   }
}

void CEventGenerator::FillWithFixWindowRandomEvent(CDataStructure *_eventStr, double _mean, double _width)
{
   // set event
   if(fRandomNumber.Rndm() >= 0.5) {
      _eventStr->operator=(fEventBufferNear);
   } else {
      _eventStr->operator=(fEventBufferFar);
   }
   // seamr peak positions
   
}

void CEventGenerator::FillWithIncreasingNumbers(CDataStructure *_eventStr)
{
   // event quality
   _eventStr->fGoodEvent       = 1;                  // find a quality definition XX
   // triger information
   _eventStr->fEventTime       = time(NULL);         //second since January 1, 1970
   _eventStr->fTriggerChannel  = -1;  
   // fill spectrum arreies
   for(int i=0; i<(_eventStr->fLocalCopyOfNumberOfADCSampels); ++i) {
      _eventStr->fDataPickup[i] = i;
      _eventStr->fDataNear[i]   = i;
      _eventStr->fDataFar[i]    = i;      
      //Test XXX
      //cout <<  _eventStr->fDataPickup[i] << "\t" <<  _eventStr->fDataNear[i] << "\t" << _eventStr->fDataFar[i] << endl;
   }
   // set new values
   _eventStr->fSlowControl.sPress     = ++fSlowControlValue;
   _eventStr->fSlowControl.sEfVoltage = ++fSlowControlValue;
   _eventStr->fSlowControl.sTemp1     = ++fSlowControlValue;
   _eventStr->fSlowControl.sTemp2     = ++fSlowControlValue;
}
