//----------------------------------------------------------------------------
//  Header: CEventGenerator.h, v 1.0                           2007/11/14   //
//                                                                          //
//  Goofie TPC ALICE Program Library                                        //
//  Copyright (C) ALICE collaboration, 2007                                 //
//                                                                          //
//  Last modified in CVS                                                    //
//  Author: D. Antonczyk                                                    //
//----------------------------------------------------------------------------

#ifndef CEVENT_GENERATOR
#define CEVENT_GENERATOR

#include "TRandom2.h"
#include "CDataStructure.h"

class CEventGenerator
{
public:
   CEventGenerator();
   ~CEventGenerator();

   unsigned int Initialize();
   
   void FillWithFixWindowRandomEvent(CDataStructure *_eventStr, double _mean, double _width);
   void FillWithRealEvent(CDataStructure *_eventStr);
   void FillWithIncreasingNumbers(CDataStructure *_eventStr);

private:
   int             fSlowControlValue;
   int             fMode;
   TRandom2        fRandomNumber;

   CDataStructure  fEventBufferNear;
   CDataStructure  fEventBufferFar;
};
#endif
