//----------------------------------------------------------------------------
//  Body: CGasAnaResults.cpp, v 1.0                           2007/07/21    //
//                                                                          //
//  Goofie TPC ALICE Program Library                                        //
//  Copyright (C) ALICE collaboration, 2007                                 //
//                                                                          //
//  Last modified in CVS                                                    //
//  Author: D. Antonczyk                                                    //
//----------------------------------------------------------------------------

#include <iostream>

#include "CMacroDef.h"

#include "CGasAnaResults.h"

using namespace std;


CGasAnaResults::CGasAnaResults() : AliGoofieGasResult()
{
   lfRun = false;
}

CGasAnaResults::CGasAnaResults(const CGasAnaResults &_val) : AliGoofieGasResult(_val)
{
   lfRun = _val.lfRun;
}

CGasAnaResults & CGasAnaResults::operator= (const CGasAnaResults &_val)
{
   if(this!=&_val) {
     
      AliGoofieGasResult & refData = *this;
      refData = _val;

      lfRun = _val.lfRun;
  }
  DEBUGINFO("Debuge Info => overloaded = operator of CGasAnaResults used",0)

 return *this;
}

CGasAnaResults::~CGasAnaResults()
{
   ;
}

void CGasAnaResults::ResetValues()
{
   Clear();
   
   lfRun = 0;
}

// test function for DIM server
void CGasAnaResults::FillDummyValue()
{
   if(lfRun==0) {
      ResetDummyValues();
      lfRun                    = 1;
   } else {
      fFieldCageHV            += 0.1;
      fPickupHV               += 0.1;
      fPeakPosNear            += 0.1; 
      fPeakPosFar             += 0.1;
      fPeakAreaNear           += 0.1;
      fPeakAreaFar            += 0.1;
      fTemp1                  += 0.1;
      fTemp2                  += 0.1;
      fPressure               += 0.1;
      fGainNear               += 0.1;
      fGainNearCorrected      += 0.1;
      fGainFar                += 0.1;
      fGainFarCorrected       += 0.1; 
      fFractionCO2            += 0.1;
      fFractionN2             += 0.1;
      fDriftVelocity          += 0.1;
      fDriftVelocityCorrected += 0.1;
      fCorrectionFactor       += 0.1;
      fNumberOfDischarge      += 1;
   }
}

void CGasAnaResults::ResetDummyValues()
{
   fFieldCageHV             = 1.0;
   fPickupHV                = 2.0;
   fPeakPosNear             = 3.0; 
   fPeakPosFar              = 4.0;
   fPeakAreaNear            = 5.0;
   fPeakAreaFar             = 6.0;
   fTemp1                   = 7.0;
   fTemp2                   = 8.0;
   fPressure                = 9.0;
   fGainNear                = 10.0;
   fGainNearCorrected       = 11.0;
   fGainFar                 = 12.0;
   fGainFarCorrected        = 13.0; 
   fFractionCO2             = 14.0;
   fFractionN2              = 15.0;
   fDriftVelocity           = 16.0;
   fDriftVelocityCorrected  = 17.0;
   fCorrectionFactor        = 18.0;
   fNumberOfDischarge       = 100;
   lfRun                    = 0;
}
