//----------------------------------------------------------------------------
//  Header: COnLineExeption.h, v 1.0                          2007/03/14    //
//                                                                          //
//  Goofie TPC ALICE Program Library                                        //
//  Copyright (C) ALICE collaboration, 2007                                 //
//                                                                          //
//  Last modified in CVS                                                    //
//  Author: D. Antonczyk                                                    //
//----------------------------------------------------------------------------


// TODO
// 1) setting stream
//
//

#include <iostream>
#include <string>
#include <iosfwd>
#include <pthread.h>

class COnLineExeption
{
public:
   COnLineExeption();
   virtual ~COnLineExeption();

   // codding errors
   // thread safe
   template <class T>
   void         SetExeptionError(unsigned int _eCode, const T *_eInfo);    // set exeption info and code
   void         PrintExeptionError();                                      // display exeption info
   std::string  GetStringExeptionError() {return feInfo;}                  // get exeption info
   unsigned int GetCodetExeptionError()  {return feCode;}                  // get exeption code
   
private:
   void         CreateMutexObject();
   
private:
   // lock access to private members of this class 
   static pthread_mutex_t  flogMutex; 
   static bool             fmutexInitialized;

   // 
   static std::ostream     fstreamSet;
   std::string             feInfo;
   unsigned int            feCode;
   static unsigned int     fOBJcounter;
};


template <class T>
void COnLineExeption::SetExeptionError(unsigned int _eCode, const T *_eInfo)
{
   // lock
   unsigned int err = pthread_mutex_lock(&flogMutex);
   // fill log
   //fstreamSet << "Code Error=" << hex << _eCode << ", " << _eInfo << endl;
   std::cerr << "Code Error=" << std::hex << _eCode << ", " << _eInfo << std::flush << std::endl;
   // unlock 
   err = pthread_mutex_unlock(&flogMutex);
   // set values
   feCode  = _eCode;
   feInfo  = _eInfo;
}
