//----------------------------------------------------------------------------
//  Body: AliGoofieGasResultcpp, v 1.0                        2007/11/19    //
//                                                                          //
//  Goofie ALICE Program Library                                            //
//  Copyright (C) ALICE collaboration, 2007                                 //
//                                                                          //
//  Last modified in CVS                                                    //
//  Author: D. Antonczyk                                                    //
//----------------------------------------------------------------------------

#include "AliGoofieGasResult.h"

using namespace std;

ClassImp(AliGoofieGasResult)
    
AliGoofieGasResult::AliGoofieGasResult() : fFieldCageHV(0.0),
					   fPickupHV(0.0),
					   fPeakPosNear(0.0),
					   fPeakPosFar(0.0),
					   fPeakAreaNear(0.0),
					   fPeakAreaFar(0.0),
					   fTemp1(0.0),
					   fTemp2(0.0),
					   fPressure(0.0),
					   fGainNear(0.0),
					   fGainNearCorrected(0.0),
					   fGainFar(0.0),
					   fGainFarCorrected(0.0),
					   fFractionCO2(0.0),
					   fFractionN2(0.0),
					   fDriftVelocity(0.0),
					   fDriftVelocityCorrected(0.0),
					   fCorrectionFactor(0.0),
					   fNumberOfDischarge(0)
{
   ;
}

AliGoofieGasResult::AliGoofieGasResult(const AliGoofieGasResult &_val)
{
   fFieldCageHV            = _val.fFieldCageHV;
   fPickupHV               = _val.fPickupHV;
   fPeakPosNear            = _val.fPeakPosNear; 
   fPeakPosFar             = _val.fPeakPosFar;
   fPeakAreaNear           = _val.fPeakAreaNear;
   fPeakAreaFar            = _val.fPeakAreaFar;
   fTemp1                  = _val.fTemp1;
   fTemp2                  = _val.fTemp2;
   fPressure               = _val.fPressure;
   fGainNear               = _val.fGainNear;
   fGainNearCorrected      = _val.fGainNearCorrected;
   fGainFar                = _val.fGainFar;
   fGainFarCorrected       = _val.fGainFarCorrected;
   fFractionCO2            = _val.fFractionCO2;
   fFractionN2             = _val.fFractionN2;
   fDriftVelocity          = _val.fDriftVelocity;
   fDriftVelocityCorrected = _val.fDriftVelocityCorrected;
   fCorrectionFactor       = _val.fCorrectionFactor;
   fNumberOfDischarge      = _val.fNumberOfDischarge;
}

AliGoofieGasResult & AliGoofieGasResult::operator= (const AliGoofieGasResult &_val)
{
   if(this!=&_val) {
      
      fFieldCageHV            = _val.fFieldCageHV;
      fPickupHV               = _val.fPickupHV;
      fPeakPosNear            = _val.fPeakPosNear; 
      fPeakPosFar             = _val.fPeakPosFar;
      fPeakAreaNear           = _val.fPeakAreaNear;
      fPeakAreaFar            = _val.fPeakAreaFar;
      fTemp1                  = _val.fTemp1;
      fTemp2                  = _val.fTemp2;
      fPressure               = _val.fPressure;
      fGainNear               = _val.fGainNear;
      fGainNearCorrected      = _val.fGainNearCorrected;
      fGainFar                = _val.fGainFar;
      fGainFarCorrected       = _val.fGainFarCorrected;
      fFractionCO2            = _val.fFractionCO2;
      fFractionN2             = _val.fFractionN2;
      fDriftVelocity          = _val.fDriftVelocity;
      fDriftVelocityCorrected = _val.fDriftVelocityCorrected;
      fCorrectionFactor       = _val.fCorrectionFactor;
      fNumberOfDischarge      = _val.fNumberOfDischarge;
   }
   return *this;
}

void AliGoofieGasResult::Clear()
{
   fFieldCageHV            = 0.0;
   fPickupHV               = 0.0;
   fPeakPosNear            = 0.0;
   fPeakPosFar             = 0.0;
   fPeakAreaNear           = 0.0;
   fPeakAreaFar            = 0.0;
   fTemp1                  = 0.0;
   fTemp2                  = 0.0;
   fPressure               = 0.0;
   fGainNear               = 0.0;
   fGainNearCorrected      = 0.0;
   fGainFar                = 0.0;
   fGainFarCorrected       = 0.0;
   fFractionCO2            = 0.0;
   fFractionN2             = 0.0;
   fDriftVelocity          = 0.0;
   fDriftVelocityCorrected = 0.0;
   fCorrectionFactor       = 0.0;
   fNumberOfDischarge      = 0;
}


void AliGoofieGasResult::SetResults(const AliGoofieGasResult *_val)
{
   if(this!=_val) {
      fFieldCageHV            = _val->fFieldCageHV;
      fPickupHV               = _val->fPickupHV;
      fPeakPosNear            = _val->fPeakPosNear; 
      fPeakPosFar             = _val->fPeakPosFar;
      fPeakAreaNear           = _val->fPeakAreaNear;
      fPeakAreaFar            = _val->fPeakAreaFar;
      fTemp1                  = _val->fTemp1;
      fTemp2                  = _val->fTemp2;
      fPressure               = _val->fPressure;
      fGainNear               = _val->fGainNear;
      fGainNearCorrected      = _val->fGainNearCorrected;
      fGainFar                = _val->fGainFar;
      fGainFarCorrected       = _val->fGainFarCorrected;
      fFractionCO2            = _val->fFractionCO2;
      fFractionN2             = _val->fFractionN2;
      fDriftVelocity          = _val->fDriftVelocity;
      fDriftVelocityCorrected = _val->fDriftVelocityCorrected;
      fCorrectionFactor       = _val->fCorrectionFactor;
      fNumberOfDischarge      = _val->fNumberOfDischarge;
   }
}

// test function
void AliGoofieGasResult::FillDummyValue()
{
   fFieldCageHV            += 0.1;
   fPickupHV               += 0.1;
   fPeakPosNear            += 0.1; 
   fPeakPosFar             += 0.1;
   fPeakAreaNear           += 0.1;
   fPeakAreaFar            += 0.1;
   fTemp1                  += 0.1;
   fTemp2                  += 0.1;
   fPressure               += 0.1;
   fGainNear               += 0.1;
   fGainNearCorrected      += 0.1;
   fGainFar                += 0.1;
   fGainFarCorrected       += 0.1; 
   fFractionCO2            += 0.1;
   fFractionN2             += 0.1;
   fDriftVelocity          += 0.1;
   fDriftVelocityCorrected += 0.1;
   fCorrectionFactor       += 0.1;
   fNumberOfDischarge      += 1;
}


void AliGoofieGasResult::DumpValues(std::ostream &strm)
{
   strm << "Field Cage HV            = " << fFieldCageHV            << "\n"
	<< "Pickup HV                = " << fPickupHV               << "\n"
      	<< "Temp 1                   = " << fTemp1                  << "\n"
	<< "Temp 2                   = " << fTemp2                  << "\n"
	<< "Pressure                 = " << fPressure               << "\n"
	<< "Peak Pos Near            = " << fPeakPosNear            << "\n"
	<< "Peak Pos Far             = " << fPeakPosFar             << "\n"
	<< "Peak Area Near           = " << fPeakAreaNear           << "\n"
	<< "Peak Area Far            = " << fPeakAreaFar            << "\n"
	<< "Gain Near                = " << fGainNear               << "\n"
	<< "Gain Near Corrected      = " << fGainNearCorrected      << "\n"
	<< "Gain Far                 = " << fGainFar                << "\n"
	<< "Gain Far Corrected       = " << fGainFarCorrected       << "\n"
	<< "Fraction CO2             = " << fFractionCO2            << "\n"
	<< "Fraction N2              = " << fFractionN2             << "\n"
	<< "Drift Velocity           = " << fDriftVelocity          << "\n"
	<< "Drift Velocity Corrected = " << fDriftVelocityCorrected << "\n"
	<< "P/TU Correction Factor   = " << fCorrectionFactor       << "\n"
	<< "Number Of Discharge      = " << fNumberOfDischarge      << endl;
}
