//----------------------------------------------------------------------------
//  Header: AliGoofieFitFunction.h, v 1.0                     2008/08/02    //
//                                                                          //
//  Goofie ALICE Program Library                                            //
//  Copyright (C) ALICE collaboration, 2008                                 //
//                                                                          //
//  Last modified in CVS                                                    //
//  Author: D. Antonczyk                                                    //
//----------------------------------------------------------------------------

#ifndef ALIGOOFIEFITFUNCTION
#define ALIGOOFIEFITFUNCTION

class TMinuit;
class TF1;
class TH1D;
class AliGoofiePeakProperties;


class AliGoofieFitFunction
{
public:
   AliGoofieFitFunction();
   ~AliGoofieFitFunction();

   static Double_t G4Fit(Double_t *x, Double_t *par);
   static void     fcn(Int_t &npar, Double_t *gin, Double_t &f, Double_t *par, Int_t iflag);

   bool MakeFit(TH1D *_histo, AliGoofiePeakProperties *_peakPropert);
   bool MakeGaussFit(TH1D *_histo, AliGoofiePeakProperties *_peakPropert);

   TF1 *GetFitResults(AliGoofiePeakProperties *_peakPropert);
   TF1 *GetGaussFitResults(AliGoofiePeakProperties *_peakPropert);

   static TH1D     *gfSpectrumToFit;
   static Int_t     gfBinStart;
   static Int_t     gfBinStop;
   static Double_t  gfChi2;

private:
   TMinuit   *fMinuit;
   TF1       *fFitResult;
   TF1       *fGaussFit;
};
#endif
