//----------------------------------------------------------------------------
//  Header: AliGoofieGasCompositionAnalysis.h, v 1.0            2009/01/30  //
//                                                                          //
//  Goofie ALICE Program Library                                            //
//  Copyright (C) ALICE collaboration, 2009                                 //
//                                                                          //
//  Last modified in CVS                                                    //
//  Author: D. Antonczyk                                                    //
//----------------------------------------------------------------------------

#ifndef ALIGOOFIEGASCOMPOSITIONANALYSIS
#define ALIGOOFIEGASCOMPOSITIONANALYSIS

#include <deque>

class AliGoofieGasCompositionAnalysis
{
public:
   AliGoofieGasCompositionAnalysis();
   AliGoofieGasCompositionAnalysis(const AliGoofieGasCompositionAnalysis &_obj);
   AliGoofieGasCompositionAnalysis & operator= (const AliGoofieGasCompositionAnalysis &_obj);
   ~AliGoofieGasCompositionAnalysis();

   Bool_t    CalculateGasComposition(TH1D *_hAmpNear,  TH1D *_hAmpFar,
				     TH1D *_hAreaNear, TH1D *_hAreaFar);
   Bool_t    CalculateFractionOfCO2AndN2();
   Double_t  GetGainFromPeak(TH1D *_hPeak) throw(int);
   void      SetGasResultsPrt(AliGoofieGasResult *_prtGasAnalysis)        {fGasAnalysisResults = _prtGasAnalysis;}
   TH2D     *GetPrtToGainNearVsGasDensity()                               {return fhGainNearVsGasDensity;}
   TH2D     *GetPrtToGainFarVsGasDensity()                                {return fhGainFarVsGasDensity;}
   Double_t  GetMeanP_T();
   Double_t  GetMeanGasGainNear();
   Double_t  GetMeanGasGainFar();

public:
   TH2D                        *fhGainNearVsGasDensity;
   TH2D                        *fhGainFarVsGasDensity;
   AliGoofieGasResult          *fGasAnalysisResults;
   std::deque<double>           fP_T_Value;
   std::deque<double>           fGasGainNear_Value;
   std::deque<double>           fGasGainFar_Value;
};
#endif
