//----------------------------------------------------------------------------
//  Header: CGoofieBoard.h,v 1.0                                2006/01/20  //
//                                                                          //
//  Goofie TPC ALICE Program Library                                        //
//  Copyright (C) ALICE collaboration, 2006                                 //
//                                                                          //
//  Declaration of class CGoofieBoard                                       //
//  Last modified in CVS                                                    //
//  Author: D. Antonczyk                                                    //
//----------------------------------------------------------------------------

#ifndef CGOOFIEBOARD_H
#define CGOOFIEBOARD_H

#include <string>

class COnLineExeption;
class CDataStructure;
class CGUnpack;

class CGoofieBoard
{
public:
   CGoofieBoard();
   virtual ~CGoofieBoard();

   // initialization
   unsigned int     InitializeCard(const std::string _configFile="");
   unsigned int     SetReadMode(bool _updata);
   unsigned int     GetEvent(CDataStructure *_eventStr);
   void             SetConfigurationFileName(const std::string _cfName)   {fconfigurationFileName=_cfName;}

private:
   CGUnpack        *unpackObj;                  // object responsible for data reading and unpacking from GOOFIE board.
   int              funpackStat;                // unpacking RAW data on-1/off-0
   int              ftriggerMode;               // select trigger case signal-1/software-0
   bool             fswappedTriggerChannels;    // check to which input the trigger channel is connected (hardware config file variable TAISN) 

   // error\exeption status
   COnLineExeption *fexeptionStatus;            // handling error mesages
   std::string      fconfigurationFileName;     // file name containing register values
};
#endif
