#include <jni.h>
#include <unistd.h>
#include <stdlib.h>
#include "SystemStarter.h"

JNIEXPORT jint JNICALL Java_core_jni_SystemStarter_readU2FActiveFecRegister
  (JNIEnv *env, jobject obj, jintArray fec_status)
  {
  	u_int ret, handle=0;
  	jint *carr;
  	
  	if(carr== NULL)
 	return (-1); /* exception occured */
 	
  	/* Get the pointer to the primitive array */
	carr = (*env)->GetIntArrayElements (env, fec_status, NULL);
  	
  	/* Open FEC_LIB */
  	ret = FEC_Open(DEFAULT_NODE, &handle);  
	CHECK_RET(ret);
  
  	/* Open U2F_LIB */
  	ret = U2F_Open(DEFAULT_NODE, &handle);
  	CHECK_RET(ret);
  
  	/* Read the Status of FECs*/
    ret = FEC_All_Status(handle, &carr[0]);
    CHECK_RET(ret);
  	
  	/* This will release the pointer to the primitive array */
  	(*env) -> ReleaseIntArrayElements(env, fec_status, carr,0);
  
  	/* Close the U2F */
  	ret = U2F_Close(handle);
  	CHECK_RET(ret);
  
  	/* Close FEC_LIB */
  	ret = FEC_Close(handle);
  	CHECK_RET(ret);
  
  	return ret;
  }
