#include <jni.h>
#include <unistd.h>
#include <stdlib.h>
#include "U2FCommandSend.h"

JNIEXPORT jint JNICALL Java_core_jni_u2f_U2FCommandSend_u2fReset (JNIEnv *env, jobject obj)
{
	u_int ret,handle=0;
  	
  	/* Open FEC_LIB */
  	ret = FEC_Open(DEFAULT_NODE, &handle);  
  	CHECK_RET(ret);
  
  	/* Open U2F_LIB */
  	ret = U2F_Open(DEFAULT_NODE, &handle);
  	CHECK_RET(ret);
  
	ret = U2F_Reset(handle);
	CHECK_RET(ret);
	
	ret = FEC_Close(handle);
	CHECK_RET(ret);
	
	ret = U2F_Close(handle);
	CHECK_RET(ret);
	
	return ret;
}

JNIEXPORT jint JNICALL Java_core_jni_u2f_U2FCommandSend_writeU2FRegTRCFG1 (JNIEnv *env, jobject obj, jint regData)
{
	u_int ret,handle=0;
  	
  	/* Open FEC_LIB */
  	ret = FEC_Open(DEFAULT_NODE, &handle);  
  	CHECK_RET(ret);
  
  	/* Open U2F_LIB */
  	ret = U2F_Open(DEFAULT_NODE, &handle);
  	CHECK_RET(ret);
  
	ret = U2F_Reg_Write(handle, O_TRCFG1, regData);
	CHECK_RET(ret);
	
	return ret;
}

JNIEXPORT jint JNICALL Java_core_jni_u2f_U2FCommandSend_writeU2FRegFMIREG (JNIEnv *env, jobject obj, jint regData)
{
	u_int ret,handle=0;
	
  	/* Open FEC_LIB */
  	ret = FEC_Open(DEFAULT_NODE, &handle);  
  	CHECK_RET(ret);
  
  	/* Open U2F_LIB */
  	ret = U2F_Open(DEFAULT_NODE, &handle);
  	CHECK_RET(ret);
  
	ret = U2F_Reg_Write(handle, O_FMIREG, regData);
	CHECK_RET(ret);
	
	return ret;
}

JNIEXPORT jint JNICALL Java_core_jni_u2f_U2FCommandSend_writeU2FRegFMOREG (JNIEnv *env, jobject obj, jint regData)
{
	u_int ret,handle=0;
	
  	/* Open FEC_LIB */
  	ret = FEC_Open(DEFAULT_NODE, &handle);  
  	CHECK_RET(ret);
  
  	/* Open U2F_LIB */
  	ret = U2F_Open(DEFAULT_NODE, &handle);
  	CHECK_RET(ret);
  
	ret = U2F_Reg_Write(handle, O_FMOREG, regData);
	CHECK_RET(ret);
	
	return ret;
}

JNIEXPORT jint JNICALL Java_core_jni_u2f_U2FCommandSend_writeU2FRegRESREG (JNIEnv *env, jobject obj, jint regData)
{
	u_int ret,handle=0;
	
  	/* Open FEC_LIB */
  	ret = FEC_Open(DEFAULT_NODE, &handle);  
  	CHECK_RET(ret);
  
  	/* Open U2F_LIB */
  	ret = U2F_Open(DEFAULT_NODE, &handle);
  	CHECK_RET(ret);
  
	ret = U2F_Reg_Write(handle, O_RESREG, regData);
	CHECK_RET(ret);
	
	return ret;
}

JNIEXPORT jint JNICALL Java_core_jni_u2f_U2FCommandSend_readAllU2FRegisters (JNIEnv *env, jobject obj, jintArray data)
{
  u_int ret,handle=0, index=0;	  
  jint *reg_data;
  
  /* Open FEC_LIB */
  ret = FEC_Open(DEFAULT_NODE, &handle);  
  CHECK_RET(ret);
  
  /* Open U2F_LIB */
  ret = U2F_Open(DEFAULT_NODE, &handle);
  CHECK_RET(ret);
 
  if(reg_data== NULL)
 	return (-1); /* exception occured */
 	
  /* Get the pointer to the primitive array */
  reg_data = (*env)->GetIntArrayElements (env, data, NULL);
  
  u_int regSData=0;  
  	/* Read the register for 15 times */
  	ret = U2F_Reg_Read(handle, O_ERRST , &regSData);
  	CHECK_RET(ret)
  	reg_data[index] = regSData & 0x0000000f;
  	index++;
  	ret = U2F_Reg_Read(handle, O_TRCFG1 , &regSData);
  	CHECK_RET(ret)
	reg_data[index] = regSData & 0xffffffff;
  	index++; 
  	ret = U2F_Reg_Read(handle, O_TRCNT , &regSData);
  	CHECK_RET(ret)
  	reg_data[index] = regSData & 0xffffffff;
  	index++;
  	ret = U2F_Reg_Read(handle, O_LWADD , &regSData);
  	CHECK_RET(ret)
  	reg_data[index] = regSData & 0x0000ffff;
  	index++;
  	ret = U2F_Reg_Read(handle, O_IRADD , &regSData);
  	CHECK_RET(ret)
  	reg_data[index] = regSData & 0x000fffff;
  	index++;
    ret = U2F_Reg_Read(handle, O_IRDAT , &regSData);
  	CHECK_RET(ret)
  	reg_data[index] = regSData & 0x000fffff;
  	index++;
  	ret = U2F_Reg_Read(handle, O_EVWORD , &regSData);
  	CHECK_RET(ret)
  	reg_data[index] = regSData & 0x0000001f;
  	index++;
  	ret = U2F_Reg_Read(handle, O_ACTFEC , &regSData);
  	CHECK_RET(ret)
  	reg_data[index] = regSData & 0x00001fff;
  	index++;
  	ret = U2F_Reg_Read(handle, O_FMIREG , &regSData);
  	CHECK_RET(ret)
  	reg_data[index] = regSData & 0x0000ffff;
  	index++;
  	ret = U2F_Reg_Read(handle, O_FMOREG , &regSData);
  	CHECK_RET(ret)
  	reg_data[index] = regSData & 0x000000ff;
  	index++;
  	ret = U2F_Reg_Read(handle, O_TRCFG2 , &regSData);
  	CHECK_RET(ret)
  	reg_data[index] = regSData & 0x00000003;
  	index++;
  	ret = U2F_Reg_Read(handle, O_RESREG , &regSData);
  	CHECK_RET(ret)
  	reg_data[index] = regSData & 0x0000ffff;
  	index++;
  	ret = U2F_Reg_Read(handle, O_ERRREG , &regSData);
  	CHECK_RET(ret)
  	reg_data[index] = regSData & 0x00000003;
  	index++;
  	ret = U2F_Reg_Read(handle, O_INTMOD , &regSData);
  	CHECK_RET(ret)
  	reg_data[index] = regSData & 0x00000003;
  	index++;
  	ret = U2F_Reg_Read(handle, O_INTREG , &regSData);
  	CHECK_RET(ret)
  	reg_data[index] = regSData & 0x0000ffff;
 
  /* This will release the pointer to the primitive array */
  (*env) -> ReleaseIntArrayElements(env, data, reg_data,0);
  
  /* Close the U2F */
  ret = U2F_Close(handle);
  CHECK_RET(ret);
  
  /* Close FEC_LIB */
  ret = FEC_Close(handle);
  CHECK_RET(ret);
  
  return ret;
}

JNIEXPORT jint JNICALL Java_core_jni_u2f_U2FCommandSend_resetStatus (JNIEnv *env, jobject obj)
{
	u_int ret,handle=0;
	
	/* Open FEC_LIB */
      ret = FEC_Open(DEFAULT_NODE, &handle);  
      CHECK_RET(ret);
      
      /* Open U2F_LIB */
	  ret = U2F_Open(DEFAULT_NODE, &handle);
	  CHECK_RET(ret);
	  
	  ret = U2F_Exec_RS_STATUS(handle);
	  CHECK_RET(ret);
	  
	  return ret;
}

JNIEXPORT jint JNICALL Java_core_jni_u2f_U2FCommandSend_resetTriggerConfig (JNIEnv *env, jobject obj)
{
	u_int ret,handle=0;
	
	/* Open FEC_LIB */
      ret = FEC_Open(DEFAULT_NODE, &handle);  
      CHECK_RET(ret);
      
      /* Open U2F_LIB */
	  ret = U2F_Open(DEFAULT_NODE, &handle);
	  CHECK_RET(ret);
	  
	  ret = U2F_Exec_RS_TRCFG(handle);
	  CHECK_RET(ret);
	  
	  return ret;
}

JNIEXPORT jint JNICALL Java_core_jni_u2f_U2FCommandSend_resetTriggerCounter (JNIEnv *env, jobject obj)
{
	u_int ret, handle=0;
	
	/* Open FEC_LIB */
      ret = FEC_Open(DEFAULT_NODE, &handle);  
      CHECK_RET(ret);
      
      /* Open U2F_LIB */
	  ret = U2F_Open(DEFAULT_NODE, &handle);
	  CHECK_RET(ret);
	  
	  ret= U2F_Exec_RS_TRCNT(handle);
	  CHECK_RET(ret);
	  
	  return ret;
}

JNIEXPORT jint JNICALL Java_core_jni_u2f_U2FCommandSend_abort (JNIEnv *env, jobject obj)
{
	u_int ret, handle=0;
	
	/* Open FEC_LIB */
      ret = FEC_Open(DEFAULT_NODE, &handle);  
      CHECK_RET(ret);
      
      /* Open U2F_LIB */
	  ret = U2F_Open(DEFAULT_NODE, &handle);
	  CHECK_RET(ret);
	  
	  ret = U2F_Exec_ABORT(handle);
	  CHECK_RET(ret);
	  
	  return ret;
}

JNIEXPORT jint JNICALL Java_core_jni_u2f_U2FCommandSend_resetGlobalFec (JNIEnv *env, jobject obj)
{
	u_int ret, handle=0;
	
	/* Open FEC_LIB */
      ret = FEC_Open(DEFAULT_NODE, &handle);  
      CHECK_RET(ret);
      
      /* Open U2F_LIB */
	  ret = U2F_Open(DEFAULT_NODE, &handle);
	  CHECK_RET(ret);
	  
	  ret = U2F_Exec_FECRST(handle);
	  CHECK_RET(ret);
	  
	  return ret;
}

JNIEXPORT jint JNICALL Java_core_jni_u2f_U2FCommandSend_softwareTrigger (JNIEnv *env, jobject obj) 
{
	u_int ret, handle=0;
	
	/* Open FEC_LIB */
      ret = FEC_Open(DEFAULT_NODE, &handle);  
      CHECK_RET(ret);
      
      /* Open U2F_LIB */
	  ret = U2F_Open(DEFAULT_NODE, &handle);
	  CHECK_RET(ret);
	  
	  ret = U2F_Exec_SWTRG(handle);
	  CHECK_RET(ret);
	  
	  return ret;
}

JNIEXPORT jint JNICALL Java_core_jni_u2f_U2FCommandSend_resetDmem1Flag (JNIEnv *env, jobject obj)
{
	u_int ret, handle=0;
	
	/* Open FEC_LIB */
      ret = FEC_Open(DEFAULT_NODE, &handle);  
      CHECK_RET(ret);
      
      /* Open U2F_LIB */
	  ret = U2F_Open(DEFAULT_NODE, &handle);
	  CHECK_RET(ret);
		
	  ret = U2F_Exec_RS_DMEM1(handle);
	  CHECK_RET(ret);
	  
	  return ret;
}

JNIEXPORT jint JNICALL Java_core_jni_u2f_U2FCommandSend_resetDmem2Flag (JNIEnv *env, jobject obj)
{
	u_int ret,handle=0;
	
	/* Open FEC_LIB */
      ret = FEC_Open(DEFAULT_NODE, &handle);  
      CHECK_RET(ret);
      
      /* Open U2F_LIB */
	  ret = U2F_Open(DEFAULT_NODE, &handle);
	  CHECK_RET(ret);
	  
	   ret = U2F_Exec_RS_DMEM2(handle);
	  CHECK_RET(ret);
	  
	  return ret;
}

JNIEXPORT jint JNICALL Java_core_jni_u2f_U2FCommandSend_resetEword (JNIEnv *env, jobject obj)
{
	u_int ret, handle=0;
	
	/* Open FEC_LIB */
      ret = FEC_Open(DEFAULT_NODE, &handle);  
      CHECK_RET(ret);
      
      /* Open U2F_LIB */
	  ret = U2F_Open(DEFAULT_NODE, &handle);
	  CHECK_RET(ret);
	  
	  ret = U2F_Reset(handle);
	  CHECK_RET(ret);
	  
	  return ret;
}

JNIEXPORT jint JNICALL Java_core_jni_u2f_U2FCommandSend_fecBroadcastBC(JNIEnv *env, jobject obj, jint regAdd, jint regData)
{
	u_int ret, handle=0;
	
	/* Open FEC_LIB */
      ret = FEC_Open(DEFAULT_NODE, &handle);  
      CHECK_RET(ret);
      
      /* Open U2F_LIB */
	  ret = U2F_Open(DEFAULT_NODE, &handle);
	  CHECK_RET(ret);
	  
	  ret = FEC_Broadcast_BC(handle, regAdd, regData);
	  CHECK_RET(ret);
	  
	  return ret;
}

JNIEXPORT jint JNICALL Java_core_jni_u2f_U2FCommandSend_fecBroadcastAL(JNIEnv *env, jobject obj, jint regAdd, jint regData)
{
	u_int ret, handle=0;
	
	/* Open FEC_LIB */
      ret = FEC_Open(DEFAULT_NODE, &handle);  
      CHECK_RET(ret);
      
      /* Open U2F_LIB */
	  ret = U2F_Open(DEFAULT_NODE, &handle);
	  CHECK_RET(ret);
	  
	  ret = FEC_Broadcast_AL(handle, regAdd, regData);
	  CHECK_RET(ret);
	  
	  return ret;
}

JNIEXPORT jint JNICALL Java_core_jni_u2f_U2FCommandSend_InitializePartition (JNIEnv *env, jobject obj, jstring filePath)
{
	u_int ret,handle=0;
	
	/* Open FEC_LIB */
      ret = FEC_Open(DEFAULT_NODE, &handle);  
      CHECK_RET(ret);
      
      /* Open U2F_LIB */
	  ret = U2F_Open(DEFAULT_NODE, &handle);
	  CHECK_RET(ret);
	
	char fname[400];
	
	int len = (*env)->GetStringUTFLength(env, filePath);
	
	(*env)->GetStringUTFRegion(env, filePath, 0, len, fname);
	
	printf("JNI_FecPartitionConfiguration_Initialize_Partition: Configuration File Path -> %s", fname); 
	
	ret = FEC_Initialize_Partition(handle, fname);
	CHECK_RET(ret);
	
	return ret;
}
