package core.jni.u2f;

import javax.swing.JOptionPane;

public class U2FCommandSend {
	
	private native int resetStatus();
	private native int resetTriggerConfig();
	private native int resetTriggerCounter();
	private native int abort();
	private native int resetGlobalFec();
	private native int softwareTrigger();
	private native int resetDmem1Flag();
	private native int resetDmem2Flag();
	private native int resetEword();
	private native int fecBroadcastBC(int regAdd, int regData);
	private native int fecBroadcastAL(int regAdd, int regData);
	private native int InitializePartition(String filePath);
	private native int readAllU2FRegisters(int[] regData);
	private native int writeU2FRegTRCFG1(int regData);
	private native int writeU2FRegFMIREG(int regData);
	private native int writeU2FRegFMOREG(int regData);
	private native int writeU2FRegRESREG(int regData);
	private native int u2fReset();	
	
	public void U2FReset()
	{
		int ret=0;
		
		try
		{
		    ret = u2fReset();
			
			if (ret !=0)
			{
				JOptionPane.showMessageDialog(null, "An Error has occured while reseting U2F, please try again!");
			}
			
		}
		catch(Exception e)
		{
			e.printStackTrace();
			JOptionPane.showMessageDialog(null, "An Error has occured while reseting U2F, please try again!");
			
		}
	}
	
	public void writeU2FRegTrcfg1(int regData)
	{
		int ret=0;
		
		try
		{
		    ret = writeU2FRegTRCFG1(regData);
			
			if (ret !=0)
			{
				JOptionPane.showMessageDialog(null, "An Error has occured while writing to U2F:TRCFG1 Register, please try again!");
			}
			
		}
		catch(Exception e)
		{
			e.printStackTrace();
			JOptionPane.showMessageDialog(null, "An Error has occured while U2F:TRCFG1 Register, please try again!");
			
		}
	}
	
	public void writeU2FRegFmireg(int regData)
	{
		int ret=0;
		
		try
		{
		    ret = writeU2FRegFMIREG(regData);
			
			if (ret !=0)
			{
				JOptionPane.showMessageDialog(null, "An Error has occured while writing to U2F:FMIREG Register, please try again!");
			}
			
		}
		catch(Exception e)
		{
			e.printStackTrace();
			JOptionPane.showMessageDialog(null, "An Error has occured while writing to U2F:FMIREG Register, please try again!");
			
		}
	}
	
	public void writeU2FRegFmoreg(int regData)
	{
		int ret=0;
		
		try
		{
		    ret = writeU2FRegFMOREG(regData);
			
			if (ret !=0)
			{
				JOptionPane.showMessageDialog(null, "An Error has occured while writing to U2F:FMOREG Register, please try again!");
			}
			
		}
		catch(Exception e)
		{
			e.printStackTrace();
			JOptionPane.showMessageDialog(null, "An Error has occured while writing to U2F:FMOREG Register, please try again!");
			
		}
	}
	
	public void writeU2FRegResreg(int regData)
	{
		int ret=0;
		
		try
		{
		    ret = writeU2FRegRESREG(regData);
			
			if (ret !=0)
			{
				JOptionPane.showMessageDialog(null, "An Error has occured while writing to U2F:RESREG Register, please try again!");
			}
			
		}
		catch(Exception e)
		{
			e.printStackTrace();
			JOptionPane.showMessageDialog(null, "An Error has occured while writing to U2F:RESREG, please try again!");
			
		}
	}
	
	public void readU2FRegisters(int[] regData)
	{
		int ret=0;
		
		try
		{
		    ret = readAllU2FRegisters(regData);
			
			if (ret !=0)
			{
				JOptionPane.showMessageDialog(null, "An Error has occured while reading U2F Registers, please try again!");
			}
			
		}
		catch(Exception e)
		{
			e.printStackTrace();
			JOptionPane.showMessageDialog(null, "An Error has occured while  reading U2F Registers, please try again!");
			
		}
	}
	
	public void initializeFecPartiontion(String filePath)
	{
		String path = filePath; int ret=0;
		
		if ( path.length() !=0)
		{
			try
			{
			    ret = InitializePartition(path);
    			
				if (ret !=0)
				{
					JOptionPane.showMessageDialog(null, "An Error has occured while loading FEC Partition Configuration, please try again!");
				}
				
			}
			catch(Exception e)
			{
				e.printStackTrace();
				JOptionPane.showMessageDialog(null, "An Error has occured while loading FEC Partition Configuration, please try again!");
				
			}
		}
		else
		{
			JOptionPane.showMessageDialog(null, "You have entered an invalid file path, please enter again!");
		}
	}
	
	public int resetStatusU2F()
	{
		try
		{
			return resetStatus();
		}
		catch (Exception e)
		{
			e.printStackTrace();
			return 1;
		}
	}
	public int resetTriggerConfigU2F()
	{
		try
		{
			return resetTriggerConfig();
		}
		catch (Exception e)
		{
			e.printStackTrace();
			return 1;
		}
	}
	public int resetTriggerCounterU2F()
	{
		try
		{
			return resetTriggerCounter();
		}
		catch (Exception e)
		{
			e.printStackTrace();
			return 1;
		}
	}
	public int abortU2F()
	{
		try
		{
			return abort();
		}
		catch (Exception e)
		{
			e.printStackTrace();
			return 1;
		}
	}
	public int resetGlobalFecU2F()
	{
		try
		{
			return resetGlobalFec();
		}
		catch (Exception e)
		{
			e.printStackTrace();
			return 1;
		}
	}
	
	public int softwareTriggerU2F()
	{
		try
		{
			return softwareTrigger();
		}
		catch (Exception e)
		{
			e.printStackTrace();
			return 1;
		}
	}
	public int resetDmem1FlagU2F()
	{
		try
		{
			return resetDmem1Flag();
		}
		catch (Exception e)
		{
			e.printStackTrace();
			return 1;
		}
	}
	public int resetDmem2FlagU2F()
	{
		try
		{
			return resetDmem2Flag();
		}
		catch (Exception e)
		{
			e.printStackTrace();
			return 1;
		}
	}
	public int resetEwordU2F()
	{
		try
		{
			return resetEword();
		}
		catch (Exception e)
		{
			e.printStackTrace();
			return 1;
		}
	}
	public int fecBroadcastBCU2F(int regAdd, int regData)
	{
		try
		{
			return fecBroadcastBC(regAdd, regData);
		}
		catch (Exception e)
		{
			e.printStackTrace();
			return 1;
		}
	}
	public int fecBroadcastALU2F(int regAdd, int regData)
	{
		try
		{
			return fecBroadcastAL(regAdd,regData );
		}
		catch (Exception e)
		{
			e.printStackTrace();
			return 1;
		}
	}
	
	static
	{
		System.loadLibrary("jniu2f");
	}
}
