package core.modules.fec;

import java.awt.Event;

import javax.swing.ImageIcon;
import javax.swing.JOptionPane;

import org.netbeans.lib.awtextra.*;
import core.modules.fec.altro.AltroGui;
import core.modules.fec.bcontrol.BCHealthMonitorPanel;
import core.modules.fec.bcontrol.BCOtherRegisterPanel;
import core.modules.fec.bcontrol.BCRegisterManager;
import core.modules.fec.bcontrol.BCConfigRegisterPanel;
import core.modules.fec.tools.FecToFromAllConfigurator;
import core.global.GlobalVariables;
/*
 * FECPanelBean.java
 *
 * Created on December 21, 2005, 11:25 AM
 */

/**
 *
 * @author  okhalid
 */
public class FecGui extends javax.swing.JPanel {
    
    /**
	 * 
	 */
    private static final long serialVersionUID = 1L;
	/** Creates new form FECPanelBean */
    public FecGui(int fecNum) {
    	setInternalFecCounter(fecNum);
        initComponents();
        addAltroPanel();
        addFecBCPanel();
        addFecControlPanel();
       // addFecConfiguratorPanel();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jAltroTabPane = new javax.swing.JTabbedPane();
        jBCTabPane = new javax.swing.JTabbedPane();
        jBCControlPanel = new javax.swing.JPanel();
        jFecControlPanel = new javax.swing.JPanel();
        bcReadAllBtn = new javax.swing.JButton();
        switchOnBtn = new javax.swing.JButton("Power");
        jBCRegWriteCmbx =  new javax.swing.JComboBox();
        	
        jFecControlPanel.setBackground(new java.awt.Color(255, 255, 204));
        jFecControlPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Fec Global"));
        jFecControlPanel.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());
        
        jBCControlPanel.setBackground(new java.awt.Color(255, 255, 204));
        jBCControlPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("BC Global"));
        jBCControlPanel.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());
        
        bcReadAllBtn.setText("Read All");
        bcReadAllBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BCReadAllHandler(evt);
            }
        });
        
        jBCControlPanel.add(bcReadAllBtn, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 20, 85, 20));
        
        switchOnBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                FecPowerSwitchHandler(evt);
            }
        });
        
        jFecControlPanel.add(switchOnBtn, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 20, 100, 20));
        
        jBCRegWriteCmbx.setBackground(new java.awt.Color(204, 255, 204));
        jBCRegWriteCmbx.setModel(new javax.swing.DefaultComboBoxModel(new String[] {"- - - - -", "Counters Latch", "Counters Clear", "Clear Error Status", "Altro Reset", "BC Reset", "Start Conv. mADC" }));
        jBCRegWriteCmbx.setToolTipText("BC Register");
        jBCRegWriteCmbx.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
            	BCRegWriteOnlyListener(evt);
            }
        });
        jBCControlPanel.add(jBCRegWriteCmbx, new org.netbeans.lib.awtextra.AbsoluteConstraints(100, 20, 130, 20));
        
        setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        setToolTipText(" FecRootPanel");
        setAutoscrolls(true);
        setMinimumSize(new java.awt.Dimension(950, 540));
        setPreferredSize(new java.awt.Dimension(950, 540));
        add(jAltroTabPane, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, 600, 460));
        add(jBCTabPane, new org.netbeans.lib.awtextra.AbsoluteConstraints(610, 0, 330, 460));
        add(jFecControlPanel, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 470, 600, 70));
        add(jBCControlPanel, new org.netbeans.lib.awtextra.AbsoluteConstraints(610, 470, 330, 70));

    }// </editor-fold>//GEN-END:initComponents
    
    public void addFecBCPanel()
    {
    	try
    	{
    		
        bcManager = new BCRegisterManager(getInternalFecCounter());
        
        createBCHealthMonPanel();
        createBCConfigurationPanel();
        createBCOtherRegPanel();
        
        bcManager.initComponents();
        initPowerStatus();
    	}
    	catch(Exception e)
    	{
    		e.printStackTrace();
    	}
    }
    
    private void initPowerStatus()
    {
    	if (GlobalVariables.FEC_STATUS[getInternalFecCounter()] == 1)
    	{
    		switchOnBtn.doClick();
    	}
    }
    
    private void addFecControlPanel()
    {
    	jBCControlPanel.setVisible(true);
    }
    
    private void addFecConfiguratorPanel()
    {
    	fecConfigurator = new FecToFromAllConfigurator();
    	fecConfigurator.setVisible(false);
    	jFecControlPanel.add(fecConfigurator, new org.netbeans.lib.awtextra.AbsoluteConstraints(130, 20, 314, 20));
    }
    
    private void createBCConfigurationPanel()
    {
        /* create an instance of the container panel */
        fecBConfigPanel = new javax.swing.JPanel();
                         
        /* create an instance of altro panel */
        fecBCConfig = new BCConfigRegisterPanel(bcManager);
             
        /* add the panel to Tab */
        jBCTabPane.addTab("BC Configuration Status", fecBConfigPanel);
                 
        fecBConfigPanel.getAccessibleContext().setAccessibleParent(jBCTabPane);
                 
        /* add the altro panel object to the panel container in the tab */ 
        fecBConfigPanel.add(fecBCConfig, new org.netbeans.lib.awtextra.AbsoluteConstraints(5,5,330, 480));
        
        /* set the placement of the tab on the LEFT hand side */
        jBCTabPane.setTabPlacement(javax.swing.SwingConstants.TOP);
    }
    
    private void createBCOtherRegPanel()
    {
        /* create an instance of the container panel */
        fecBCOtherRegPanel = new javax.swing.JPanel();
                         
        /* create an instance of altro panel */
        fecBCOther = new BCOtherRegisterPanel(bcManager);
       
        /* add the panel to Tab */
        jBCTabPane.addTab("BC Other Registers", fecBCOtherRegPanel);
                 
        fecBCOtherRegPanel.getAccessibleContext().setAccessibleParent(jBCTabPane);
                 
        /* add the altro panel object to the panel container in the tab */ 
        fecBCOtherRegPanel.add(fecBCOther, new org.netbeans.lib.awtextra.AbsoluteConstraints(5,5,330, 480));
        
        /* set the placement of the tab on the LEFT hand side */
        jBCTabPane.setTabPlacement(javax.swing.SwingConstants.TOP);
    }
    
    private void createBCHealthMonPanel()
    {
        /* create an instance of the container panel */
        fecBCHealthMonPanel = new javax.swing.JPanel();
                         
        /* create an instance of altro panel */
        fecBCHealth = new BCHealthMonitorPanel(bcManager);
             
        /* add the panel to Tab */
        jBCTabPane.addTab("BC Health Monitoring", fecBCHealthMonPanel);
                 
        fecBCHealthMonPanel.getAccessibleContext().setAccessibleParent(jBCTabPane);
                 
        /* add the altro panel object to the panel container in the tab */ 
        fecBCHealthMonPanel.add(fecBCHealth, new org.netbeans.lib.awtextra.AbsoluteConstraints(5,5,330, 480));
        
        /* set the placement of the tab on the LEFT hand side */
        jBCTabPane.setTabPlacement(javax.swing.SwingConstants.TOP);
    }
    
    public void addAltroPanel()
    {
        altro = new AltroGui[GlobalVariables.MaxPerFecAltros];
        
        /* This panel will hold the altro panel object */
        altroContainerPanel = new javax.swing.JPanel[GlobalVariables.MaxPerFecAltros];
        
        for(int index=0; index < GlobalVariables.MaxPerFecAltros; index++)
        {
             /* create an instance of the container panel */
             altroContainerPanel[index] = new javax.swing.JPanel();
                         
             /* create an instance of altro panel */
             altro[index] = new AltroGui(index,getInternalFecCounter());
             
        	 /* add the panel to Tab */
        	 jAltroTabPane.addTab(("Altro " + (index+1)), altroContainerPanel[index]);
                 
             altroContainerPanel[index].getAccessibleContext().setAccessibleParent(jAltroTabPane);
             
             /* add the altro panel object to the panel container in the tab */ 
             altroContainerPanel[index].add(altro[index], new org.netbeans.lib.awtextra.AbsoluteConstraints(5,5,600, 440));
        }
        
        /* set the placement of the tab on the LEFT hand side */
        jAltroTabPane.setTabPlacement(javax.swing.SwingConstants.TOP);
    }
    
    private void BCReadAllHandler(java.awt.event.ActionEvent evt) 
    {
    	bcManager.readHealthMonRegisters();
    }
    
private void FecPowerSwitchHandler(java.awt.event.ActionEvent evt) {                                       
        
        /* If this button is clicked, update the Status Array in the GlobalVairable */
		
    	if(fecPower != ON)
    	{
    		core.global.GlobalVariables.FEC_STATUS[bcManager.getFecAdd()] = 1;
    		switchOnBtn.setBackground(new java.awt.Color(0,204,51));
    		fecPower = ON;
    	}
    	else
		{
		/* As the FEC is already On, Switch it OFF */
		core.global.GlobalVariables.FEC_STATUS[bcManager.getFecAdd()] = 0;
		switchOnBtn.setBackground(new java.awt.Color(204,51,0));
		fecPower = OFF;
		}
    } 

	private void BCRegWriteOnlyListener(java.awt.event.ItemEvent evt) 
	{
		/* Input the index value coming from the combo box, and the rest is handled by the function in the bcManager */
		if(jBCRegWriteCmbx.getSelectedIndex() !=0 )
		{
			int index =0;
			index = jBCRegWriteCmbx.getSelectedIndex() - 1;
			bcManager.writeToWriteOnlyBCRegisters(index);
			/* Set the index value back to 0 */
			jBCRegWriteCmbx.setSelectedIndex(0);
			
			JOptionPane.showMessageDialog(null, "The command has been executed !");
		}
	}

    private void setInternalFecCounter(int fecNum)
    {
    	fecTabNumber = fecNum;
    }
    
    public int getInternalFecCounter()
    {
    	return fecTabNumber;
    }

    private javax.swing.JTabbedPane jAltroTabPane;
    private javax.swing.JTabbedPane jBCTabPane;
    private javax.swing.JPanel jBCControlPanel;
    private javax.swing.JPanel jFecControlPanel;
    private javax.swing.JButton bcReadAllBtn;
    private javax.swing.JButton switchOnBtn;
    private javax.swing.JComboBox jBCRegWriteCmbx;
    // End of variables declaration                   
    
    //Non-Guarded declarations -- Can Modify
    public AltroGui[] altro;
    public javax.swing.JPanel altroContainerPanel[], fecBCHealthMonPanel, fecBConfigPanel, fecBCOtherRegPanel;
    public BCHealthMonitorPanel fecBCHealth;
    public BCConfigRegisterPanel fecBCConfig;
    public BCOtherRegisterPanel fecBCOther;
    private FecToFromAllConfigurator fecConfigurator;
    private int fecTabNumber;
    public BCRegisterManager bcManager;
    private final int ON=1;
    private final int OFF=0;
    private int fecPower=OFF; /* O=OFF, 1=ON */

}
