package gui.root;


/*
 * RootFrame.java
 *
 * Created on December 20, 2005, 11:28 AM
 */

/**
 *
 * @author  okhalid
 */
import core.global.GlobalVariables;
import core.jni.RccDebugOutput;
import core.jni.SystemStarter;
import core.modules.fec.FecGui;
import core.modules.fec.GlobalFecFileConfigGui;
import core.modules.fec.GlobalFecGui;
import core.modules.fec.tools.FecToolBar;

import java.awt.*;
import java.awt.event.ContainerEvent;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JToolBar;

import core.modules.ImplementationManager;
import core.modules.u2f.U2fManager;

public class RootFrame extends javax.swing.JFrame {
    
    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private ImplementationManager implManager;
	/** Creates new form RootFrame */
    public RootFrame() 
    {}
    
    public void run()
    {
    	initSystem();
    }
    
    public void run(ImplementationManager implMngr)
    {
    	implManager = implMngr;
    	initSystem();
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jToolBar1 = new FecToolBar();
        jToolBar2 = new javax.swing.JToolBar();
        jImplemenPanel = new javax.swing.JPanel();
        jTabbedSelection = new javax.swing.JTabbedPane();
        jFunctionTab = new javax.swing.JPanel();
        jFunctionU2FTabSelection = new javax.swing.JTabbedPane();
        jSystemTab = new javax.swing.JPanel();
        jFECTabbedPane = new javax.swing.JTabbedPane();
        jRootMenuBar = new javax.swing.JMenuBar();
        jFileMenu = new javax.swing.JMenu();
        jMenuExit = new javax.swing.JMenuItem();
        jDebugMenu = new javax.swing.JMenu();
        jMenuSetParam = new javax.swing.JMenuItem();

        setBackground(new java.awt.Color(238, 238, 238));

        jImplemenPanel.addContainerListener(new java.awt.event.ContainerAdapter() {
            public void componentAdded(java.awt.event.ContainerEvent evt) {
                jImplemenPanelComponentAdded(evt);
            }
        });

        jTabbedSelection.setTabLayoutPolicy(javax.swing.JTabbedPane.SCROLL_TAB_LAYOUT);
        jFunctionTab.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jFunctionTab.add(jFunctionU2FTabSelection, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 10, 970, 600));
        
         /* Functions tab to show U2F registers is disabled */
         /* jTabbedSelection.addTab("Functions", jFunctionTab); */

        jSystemTab.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jFECTabbedPane.setAutoscrolls(true);
        jSystemTab.add(jFECTabbedPane, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 10, 970, 600));

        jTabbedSelection.addTab("System", jSystemTab);

        org.jdesktop.layout.GroupLayout jImplemenPanelLayout = new org.jdesktop.layout.GroupLayout(jImplemenPanel);
        jImplemenPanel.setLayout(jImplemenPanelLayout);
        jImplemenPanelLayout.setHorizontalGroup(
            jImplemenPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jImplemenPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(jTabbedSelection, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 970, Short.MAX_VALUE))
        );
        jImplemenPanelLayout.setVerticalGroup(
            jImplemenPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.LEADING, jImplemenPanelLayout.createSequentialGroup()
                .add(jTabbedSelection, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 620, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        jFileMenu.setText("File");
        jMenuExit.setText("Exit");
        jMenuExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
            	applicationExitListener(evt);
            }
        });
        jFileMenu.add(jMenuExit);
        
        jRootMenuBar.add(jFileMenu);

        /* Set DEbug menu */
        jDebugMenu.setText("Debug");
        jMenuSetParam.setText("Set Parameters");
        jMenuSetParam.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
            	debugParameterListener(evt);
            }
        });
        jDebugMenu.add(jMenuSetParam);
        
        jRootMenuBar.add(jDebugMenu);
        
        /* Add the menu to the frame */
        setJMenuBar(jRootMenuBar);
        
        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jImplemenPanel)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(jToolBar1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 221, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jToolBar2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 219, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(532, 532, 532)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jToolBar1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 25, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jToolBar2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 25, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jImplemenPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 630, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    protected void jImplemenPanelComponentAdded(ContainerEvent evt) {
		// TODO Auto-generated method stub
		
	}

	private void initSystem()
    {
    	//initialise GUI
    	initComponents();
    	
    	//initialise U2F
    	 initU2F();
    	
    	/* Read Active FEC register of the U2F and set the status of the respective fec's */
    	initFecStatus();
    	
    	//initialise the FEC's
    	initFECComponents();
    	
    	//initalise the Global Fec
    	initGlobalFec();
    	
    	//This connects the FecTool bar to the RootFrame object
    	initFecTools();
    	
        //sendToConsole(bc.messageToConsole());
    }
    
	private void initFecStatus()
	{
		jniFecStatus = new SystemStarter();
		
		jniFecStatus.readU2FActiveFecRegister();
	}

    private void initU2F()
    {
    	
        u2fGui = implManager.u2fManager.getU2FGui();
       
        //create a U2F Command panelcumbh3gOK
        
        javax.swing.JPanel u2fCommandPanel = new javax.swing.JPanel();
        javax.swing.JPanel u2fRegisterPanel = new javax.swing.JPanel();
        
        //sets the absolute layout
        u2fRegisterPanel.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());
        
        //links FecObject to the FEC tab and the inserted panel init
        u2fRegisterPanel.add(u2fGui, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 10, -1, -1));
         
        // adds a new tab and fecPanel is inserted into the newly created tab
        jFunctionU2FTabSelection.addTab("U2F Registers", u2fRegisterPanel);
        
        jFunctionTab.add(jFunctionU2FTabSelection, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 10, 980, 430));
        
    }
    
    private void initFECComponents()
    {
    	//Create an array of Fec's and Fec Panels.
        fec       = new FecGui[GlobalVariables.MaxPerU2Ffecs];
        jFecPanel = new javax.swing.JPanel[GlobalVariables.MaxPerU2Ffecs];
        
        //add 16 FEC's for test purposes
        for (numberOfFecAttachedToU2F = 0; numberOfFecAttachedToU2F<GlobalVariables.MaxPerU2Ffecs; numberOfFecAttachedToU2F++ )
        {
            fec[numberOfFecAttachedToU2F] = new FecGui(fecTabNumber);
            fecTabFactory();
        }
    }

    /**
     * Level - 2 Function
     * This function should not be called directly. It provides implementation for parent function newAddFec() to create new tabs for FEC's.
     */
    private void fecTabFactory()
    {
        String fecTabName = "Fec: " + (fecTabNumber + 1);
        
        //javax.swing.JPanel fecPanelRef = newFecSubPanelFactory(fecTabNumber);
        jFecPanel[fecTabNumber] = new javax.swing.JPanel();
        
        //ImageIcon imageIcon = new ImageIcon(GlobalVariables.imagePath+"switch_off.gif");
        
        // adds a new tab and fecPanel is inserted into the newly created tab
        jFECTabbedPane.addTab(fecTabName,jFecPanel[fecTabNumber] );
        
        jFecPanel[fecTabNumber].getAccessibleContext().setAccessibleParent(jFECTabbedPane);
        
        //links FecObject to the FEC tab and the inserted panel init
        jFecPanel[fecTabNumber].add(fec[fecTabNumber], new org.netbeans.lib.awtextra.AbsoluteConstraints(5,0,980, 440));
        
        //increment facTabNumber by one as a new fec tab is added to the system
        fecTabNumber++;
    }
    
    private void initGlobalFec()
    {
//    	Create an array of Fec's and Fec Panels.
        globalFec       = new GlobalFecFileConfigGui();
        
        String fecTabName = "Global";
        
        //javax.swing.JPanel fecPanelRef = newFecSubPanelFactory(fecTabNumber);
        jGlobalFecPanel = new javax.swing.JPanel();
        
        //ImageIcon imageIcon = new ImageIcon(GlobalVariables.imagePath+"switch_off.gif");
        
        // adds a new tab and fecPanel is inserted into the newly created tab
        jFECTabbedPane.addTab(fecTabName,jGlobalFecPanel );
        
        jGlobalFecPanel.getAccessibleContext().setAccessibleParent(jFECTabbedPane);
        
        //links FecObject to the FEC tab and the inserted panel init
        jGlobalFecPanel.add(globalFec, new org.netbeans.lib.awtextra.AbsoluteConstraints(5,0,980, 440));
        
    }
    
    private void initFecTools()
    {
    	jToolBar1 = implManager.fecManager.getFecToolBar();
    }
    
    private void applicationExitListener(java.awt.event.ActionEvent evt) 
    {
    	System.exit(0);
    }
    
    private void debugParameterListener(java.awt.event.ActionEvent evt) 
    {
    	rccDebug = new RccDebugOutput();
    	
    	rccDebug.setDebugParameters();
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new RootFrame().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTabbedPane jFECTabbedPane;
    private javax.swing.JMenu jFileMenu;
    private javax.swing.JMenu jDebugMenu;
    private javax.swing.JPanel jFunctionTab;
    private javax.swing.JTabbedPane jFunctionU2FTabSelection;
    private javax.swing.JPanel jImplemenPanel;
    private javax.swing.JMenuItem jMenuExit;
    private javax.swing.JMenuItem jMenuSetParam;
    private javax.swing.JMenuBar jRootMenuBar;
    private javax.swing.JPanel jSystemTab;
    private javax.swing.JTabbedPane jTabbedSelection;
    private FecToolBar jToolBar1;
    private javax.swing.JToolBar jToolBar2;
    // End of variables declaration//GEN-END:variables
    
   
    public FecGui[] fec;
     /* public GlobalFecGui globalFec; //This was used for the previous version of the global fec */
    public GlobalFecFileConfigGui globalFec;
    public javax.swing.JPanel jGlobalFecPanel;
    public javax.swing.JPanel[] jFecPanel;
    public int numberOfFecAttachedToU2F = 0;
    public int fecTabNumber=0;
    public core.modules.u2f.U2fGui u2fGui;
    public U2fManager u2fManager;
    public FecToolBar fecTools;
    private RccDebugOutput rccDebug;
    private SystemStarter jniFecStatus;
}
