//----------------------------------------------------------------------------
//   Header: CGDataFormat.h,v 1.0                               2005/02/24  //
//                                                                          //
//  Goofie TPC ALICE Program Library                                        //
//  Copyright (C) ALICE collaboration, 2004                                 //
//                                                                          //
//  Declaration of class CGDataFormat                                       //
//  Last modified in CVS                                                    //
//  Author: D. Antonczyk                                                    //
//----------------------------------------------------------------------------

#ifndef CGDATAFORMAT_H
#define CGDATAFORMAT_H

#include <TObject.h>

class DSample;
class DTrailer;

class DFormat
{
 public:
  DSample    *dataRAW[2048];
  DTrailer   *trailer;
  int         nofSamples;

 public:
  DFormat();
  virtual ~DFormat() {}

  void        unpack_rawData(UInt_t *arr, const UInt_t &wr);
  void        fill_arr(UInt_t *arr, UInt_t &wr);
  DSample    *get_sample(int nofs)              {if(nofs<nofSamples) return  dataRAW[nofs]; else return NULL;}
  DTrailer   *get_trailer()                     {return  trailer;}
  void        clear();
};


class DTrailer
{
 public:
  UInt_t      hadd;
  UInt_t      lWords;
  UInt_t      endM[2];

 public:
  DTrailer();
  virtual ~DTrailer() {}

  UInt_t      get_hadd()            const {return hadd;}
  UInt_t      get_lWords()          const {return lWords;}
  UInt_t      get_endM(UInt_t pos)  const {if(pos<2) return endM[pos]; else return 0;}

  void clear();
};

class DSample
{
 public:
  UInt_t      *Sample;
  UInt_t       timeOFlastSample;
  UInt_t       nSample;

 private:
  void         set_sample(UInt_t pos, UInt_t s) {Sample[pos]=s;}

 public:
  DSample();
  virtual ~DSample();

  UInt_t       get_sample(UInt_t pos)    const {if(pos<nSample) return Sample[pos]; else return 0;}
  UInt_t       get_timeOFlastSample()    const {return timeOFlastSample;}
  UInt_t       get_nSample()             const {return nSample;}

  void createASample();
  void clear();
};

#endif
