//----------------------------------------------------------------------------
//  Header: CGRegVal.h,v 1.0                                 2004/11/16     //
//                                                                          //
//  Goofie TPC ALICE Program Library                                        //
//  Copyright (C) ALICE collaboration, 2004                                 //
//                                                                          //
//  Last modified in CVS                                                    //
//  Author: D. Antonczyk                                                    //
//----------------------------------------------------------------------------

#include <TObject.h>
#include <iostream>
#include <string>

class CGRegVal : public TObject
{
  friend std::ostream & operator<<(std::ostream &stream_out, CGRegVal &data_in);

 public:

  UShort_t   fZSCTL;                // zero suppression control
  UShort_t   fZSTHD;                // zero supresion threshold 
  UShort_t   fZSPED;                // fix pedestal substraction value
  UShort_t   fACTCH;                // chanel number 1=A, 2=B, 3=C  not in use
  UShort_t   fNSEVT;                // numbers of sampels per event (def :: 490 sample)
  UShort_t   fPRTRG;                // pre/post triger (bit mask)
  UShort_t   fBSLCT;                // bslct  (0=ADC-FPD, 3=MEM-FPD, 5=ACD-MEM)
  UShort_t   fTMASK;                // TRIGER  --  tmask (bit mask) 1-chA Only, 2-chB Only, 3-both
  UShort_t   fTATHD;                //             treshold for chA
  UShort_t   fTBTHD;                //             treshold for chB
  UShort_t   fIsChannelACalledNear; // 1-true, 0-false equal to "Far" trigger. 
                                    // Channel A is one of the trigger channel located at the edge of the goofie board.

  CGRegVal();
  virtual   ~CGRegVal() {}
  UShort_t   HexToDec(UShort_t &vdec) const;
  void       SetValueFromFile(std::string _fname);
  void       DefValue();
  void       Clear();

  ClassDef(CGRegVal, 1)
};

