
export PATH=./:/sbin/:/usr/sbin/:${PATH}

export CONFIG_SETTINGS='/home/dantoncz/settings'

# operating system, used in makefiles...
export OS='Linux'
export PLATF='${OS}'
export DEBUG_LEVEL=`grep "<<DEBUG_LEVEL>>" ${CONFIG_SETTINGS} | cut -d"=" -f2`

# this also may need adaption .... (needed in getdb)
export DOMAIN_NAME=`grep "<<DOMAIN_NAME>>" ${CONFIG_SETTINGS} | cut -d"=" -f2`

# ROOT
export ROOT=`grep "<<ROOT>>" ${CONFIG_SETTINGS} | cut -d"=" -f2`
export ROOT_SW_VERSION=`grep "<<ROOT_SW_VERSION>>" ${CONFIG_SETTINGS} | cut -d"=" -f2`
export ROOTSYS=${ROOT}${ROOT_SW_VERSION}
export PATH=${ROOT}${ROOT_SW_VERSION}/bin:${PATH}
export LD_LIBRARY_PATH=${ROOT}${ROOT_SW_VERSION}/lib:${LD_LIBRARY_PATH}

#-------------------------------------------------------------------------------------------------#
#----------------------------------- ON LINE GOOFIE START, ROOT must be instaled -----------------#
#-------------------------------------------------------------------------------------------------#
# DIM
export DIMDIR=`grep "<<DIMDIR>>" ${CONFIG_SETTINGS} | cut -d"=" -f2`
export DIM_DNS_NODE=`grep "<<DIM_DNS_NODE>>" ${CONFIG_SETTINGS} | cut -d"=" -f2`
export ODIR='linux'
export PATH=${DIMDIR}/${ODIR}:${PATH}
export LD_LIBRARY_PATH=${DIMDIR}/${ODIR}:${LD_LIBRARY_PATH}
# aliases
alias TestServer=${DIMDIR}/${ODIR}/testServer
alias TestClient=${DIMDIR}/${ODIR}/testClient
alias Test_server=${DIMDIR}/${ODIR}/test_server
alias Test_client=${DIMDIR}/${ODIR}/test_client
alias Dns=${DIMDIR}/${ODIR}/dns
alias Dim_get_service=${DIMDIR}/${ODIR}/dim_get_service
alias Dim_send_command=${DIMDIR}/${ODIR}/dim_send_command
alias DimBridge=${DIMDIR}/${ODIR}/DimBridge
alias Did=${DIMDIR}/${ODIR}/did

# National Instrument software
export NI_DIR=`grep "<<NIDIR>>" ${CONFIG_SETTINGS} | cut -d"=" -f2`
export LD_LIBRARY_PATH=${NI_DIR}/lib/:${LD_LIBRARY_PATH}

# Online code
export GOOFIE_ONDIR=`grep "<<GOOFIE_ONDIR>>" ${CONFIG_SETTINGS} | cut -d"=" -f2`
  # Engine
export LD_LIBRARY_PATH=${GOOFIE_ONDIR}/Linux:${LD_LIBRARY_PATH}
  # Hardware part
export LD_LIBRARY_PATH=${GOOFIE_ONDIR}/Hardware/unpacker/Linux:${LD_LIBRARY_PATH}
export LD_LIBRARY_PATH=${GOOFIE_ONDIR}/Hardware/driver/tools:${GOOFIE_ONDIR}/Hardware/driver/altro:${LD_LIBRARY_PATH}
export LD_LIBRARY_PATH=${GOOFIE_ONDIR}/Hardware/driver/goofie:${GOOFIE_ONDIR}/Hardware/driver/u2f:${GOOFIE_ONDIR}/Hardware/driver/fec:${LD_LIBRARY_PATH}
  # Anslysis part
export LD_LIBRARY_PATH=${GOOFIE_ONDIR}/GasAnalysis/Linux:${LD_LIBRARY_PATH}
  # Alerts part
export LD_LIBRARY_PATH=${GOOFIE_ONDIR}/Alert/Linux:${LD_LIBRARY_PATH}
  # DataToDisc part
export LD_LIBRARY_PATH=${GOOFIE_ONDIR}/DataToDisc/Linux:${LD_LIBRARY_PATH}
  # Detector Name (TRD or TPC)
export GOOFIE_DETECTOR_NAME=`grep "<<GOOFIE_DETECTOR_NAME>>" ${CONFIG_SETTINGS} | cut -d"=" -f2`
#-------------------------------------------------------------------------------------------------#
#----------------------------------- ON LINE GOOFIE END ------------------------------------------#
#-------------------------------------------------------------------------------------------------#

#-------------------------------------------------------------------------------------------------#
#----------------------------------- GOOFIE LOCAL DISPLAY START ----------------------------------#
#-------------------------------------------------------------------------------------------------#
export GOOFIE_LOCAL_DISPLAY=`grep "<<GOOFIE_LOCAL_DISPLAY>>" ${CONFIG_SETTINGS} | cut -d"=" -f2`
export GOOFIESYS=${GOOFIE_ONDIR}/Hardware/driver
export INTERGSYS=${GOOFIE_ONDIR}/Hardware/unpacker
export LD_LIBRARY_PATH=${GOOFIE_LOCAL_DISPLAY}/Linux/:${LD_LIBRARY_PATH}
#-------------------------------------------------------------------------------------------------#
#----------------------------------- GOOFIE LOCAL DISPLAY END  -----------------------------------#
#-------------------------------------------------------------------------------------------------#

# Goofie Analysis
export GOOFIE_ANALYSIS=`grep "<<GOOFIE_ANALYSIS>>" ${CONFIG_SETTINGS} | cut -d"=" -f2`
export PATH=${GOOFIE_ANALYSIS}RootToRes/:${PATH}
export LD_LIBRARY_PATH=${GOOFIE_ANALYSIS}RootToRes/Linux/:${LD_LIBRARY_PATH}
export PATH=${GOOFIE_ANALYSIS}NewEleRawRoot/:${PATH}
export LD_LIBRARY_PATH=${GOOFIE_ANALYSIS}NewEleRawRoot/Linux/:${LD_LIBRARY_PATH}

# garfield
export GARFIELD_DIR=`grep "<<GARFIELD_DIR>>" ${CONFIG_SETTINGS} | cut -d"=" -f2`
export PATH=${GARFIELD_DIR}/bin:${PATH}
export LD_LIBRARY_PATH=${GARFIELD_DIR}/lib:${LD_LIBRARY_PATH}


#-------------------------------------------------------------------------------------------------#
#----------------------------------------- CERES START -------------------------------------------#
#-------------------------------------------------------------------------------------------------#
# step3c
export CSEVENT_DIR=`grep "<<CSEVENT_DIR>>" ${CONFIG_SETTINGS} | cut -d"=" -f2`
export LD_LIBRARY_PATH=${CSEVENT_DIR}/Linux/:${LD_LIBRARY_PATH}
export LD_LIBRARY_PATH=${CSEVENT_DIR}/Linux/analyser/:${LD_LIBRARY_PATH}

# HBT
export HBT_PATH=`grep "<<HBT_PATH>>" ${CONFIG_SETTINGS} | cut -d"=" -f2`
export LD_LIBRARY_PATH=${HBT_PATH}/Linux:${LD_LIBRARY_PATH}

# Generator / HBT / 
export GEN_PATH=`grep "<<GEN_PATH>>" ${CONFIG_SETTINGS} | cut -d"=" -f2`
export LD_LIBRARY_PATH=${GEN_PATH}/Linux/:${LD_LIBRARY_PATH}
#-------------------------------------------------------------------------------------------------#
#----------------------------------------- CERES STOP --------------------------------------------#
#-------------------------------------------------------------------------------------------------#


# rar
#export PATH=`grep "<<RAR_PATH>>" ${CONFIG_SETTINGS} | cut -d"=" -f2`:${PATH}

# skype
#setenv SSKYPE_RESOURCES_PATH /u/dantoncz/komunikator/skype-1.3.0.53/
#setenv PATH ${SSKYPE_RESOURCES_PATH}:${PATH}

#ikf praktikum V22  <<IKFV22LAB>>
export IKFV22_LAB=`grep "<<IKFV22LAB>>" ${CONFIG_SETTINGS} | cut -d"=" -f2`
export LD_LIBRARY_PATH=${IKFV22_LAB}:${LD_LIBRARY_PATH}
